"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LocationMap = exports.EventLocationMap = exports.Map = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _CardHeader = _interopRequireDefault(require("@material-ui/core/CardHeader"));

var _mapboxGl = _interopRequireDefault(require("mapbox-gl"));

var _reactMapboxGl = _interopRequireWildcard(require("react-mapbox-gl"));

require("mapbox-gl/dist/mapbox-gl.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// created 29-apr-2019 by rich braun <docker@instantlinux.net>
// TODO this is not working with ci-test
// eslint-disable-next-line import/no-webpack-loader-syntax
_mapboxGl.default.workerClass = require('worker-loader!mapbox-gl/dist/mapbox-gl-csp-worker').default;
const Map = (0, _reactMapboxGl.default)({
  accessToken: process.env.REACT_APP_TOKEN_MAPBOX
}); // See https://labs.mapbox.com/maki-icons/  (but not all are available)

exports.Map = Map;
const markerIcon = 'marker-11';

const EventLocationMap = ({
  id
}) => {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Query, {
    type: "getOne",
    resource: "event",
    payload: {
      id: id
    }
  }, ({
    data,
    loading,
    error
  }) => loading ? /*#__PURE__*/_react.default.createElement(_reactAdmin.Loading, null) : error ? /*#__PURE__*/_react.default.createElement(_reactAdmin.Error, null) : /*#__PURE__*/_react.default.createElement(_reactAdmin.Query, {
    type: "getOne",
    resource: "location",
    payload: {
      id: data.location_id
    }
  }, ({
    data,
    loading,
    error
  }) => loading ? /*#__PURE__*/_react.default.createElement(_reactAdmin.Loading, null) : error ? /*#__PURE__*/_react.default.createElement(_reactAdmin.Error, null) : /*#__PURE__*/_react.default.createElement("div", {
    style: {
      backgroundColor: '#E0E0E0'
    }
  }, /*#__PURE__*/_react.default.createElement(_CardHeader.default, {
    title: data.address ? data.address : data.neighborhood,
    titleTypographyProps: {
      align: 'center',
      variant: 'subtitle1'
    }
  }), /*#__PURE__*/_react.default.createElement(Map // See https://github.com/alex3165/react-mapbox-gl/issues/498
  // eslint-disable-next-line
  , {
    style: "mapbox://styles/mapbox/streets-v8",
    center: data.geo,
    zoom: [data.address ? 15 : 11],
    containerStyle: {
      height: "30vh",
      width: "50vw"
    }
  }, /*#__PURE__*/_react.default.createElement(_reactMapboxGl.Layer, {
    type: "symbol",
    id: "marker",
    layout: {
      'icon-image': data.address ? markerIcon : 'circle-15'
    }
  }, /*#__PURE__*/_react.default.createElement(_reactMapboxGl.Feature, {
    coordinates: data.geo
  })), data.name && /*#__PURE__*/_react.default.createElement(_reactMapboxGl.Marker, {
    coordinates: data.geo,
    anchor: "top"
  }, data.name)))));
};

exports.EventLocationMap = EventLocationMap;

const LocationMap = data => {
  return /*#__PURE__*/_react.default.createElement(Map // eslint-disable-next-line
  , {
    style: "mapbox://styles/mapbox/streets-v8",
    center: data.geo,
    zoom: [data.address ? 15 : 11],
    containerStyle: {
      height: "30vh",
      width: "50vw"
    }
  }, /*#__PURE__*/_react.default.createElement(_reactMapboxGl.Layer, {
    type: "symbol",
    id: "marker",
    layout: {
      'icon-image': markerIcon
    }
  }, /*#__PURE__*/_react.default.createElement(_reactMapboxGl.Feature, {
    coordinates: data.geo
  })), data.name && /*#__PURE__*/_react.default.createElement(_reactMapboxGl.Marker, {
    coordinates: data.geo,
    anchor: "top"
  }, data.name));
};

exports.LocationMap = LocationMap;