"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.accountList = exports.accountEdit = exports.accountShow = exports.accountSecurity = exports.accountCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Card = _interopRequireDefault(require("@material-ui/core/Card"));

var _CardContent = _interopRequireDefault(require("@material-ui/core/CardContent"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _queryString = require("query-string");

var _raCustom = require("../lib/ra-custom");

var _validate = require("../lib/validate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const accountCreate = props => {
  const {
    forgot
  } = (0, _queryString.parse)(props.location.search);
  const forgotbool = forgot === 'true';
  return /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true,
    direction: 'column',
    spacing: 2
  }, !forgotbool && /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xl: 6,
    md: 6,
    sm: 12,
    xs: 12
  }, /*#__PURE__*/_react.default.createElement(_Card.default, null, /*#__PURE__*/_react.default.createElement(_CardContent.default, null, "Follow these steps to invite guests to your event:", /*#__PURE__*/_react.default.createElement("ul", null, /*#__PURE__*/_react.default.createElement("li", null, "Create a username"), /*#__PURE__*/_react.default.createElement("li", null, "Confirm your email"), /*#__PURE__*/_react.default.createElement("li", null, "Create a password"), /*#__PURE__*/_react.default.createElement("li", null, "Add your location"), /*#__PURE__*/_react.default.createElement("li", null, "Fill out the event form")), "You can also return here if you ever forget your password."))), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xl: 6,
    md: 6,
    sm: 12,
    xs: 12
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, _extends({}, props, {
    title: "Account Registration"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: "/confirmwait",
    toolbar: /*#__PURE__*/_react.default.createElement(RegisterToolbar, null)
  }, /*#__PURE__*/_react.default.createElement(RegisterForm, {
    forgot: forgotbool
  })))));
}; // TODO verify_password
// (value) => value === watch('new_password')


exports.accountCreate = accountCreate;

const accountSecurity = ({
  permissions,
  ...props
}) => {
  const uid = sessionStorage.getItem('uid');
  const auth = sessionStorage.getItem('auth'); // console.log('auth=' + sessionStorage.getItem('auth'))
  // TODO redirect to logout; it goes to Not Found unless set to /

  const redir = auth.includes('user') ? '/welcome?buttons=login' : '/';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(MenuUpdateTitle, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, {
    redirect: redir
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "password"
  }, permissions && String(permissions).match(/user|pwchange/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "old_password",
    type: "password"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "new_password",
    type: "password",
    validate: _validate.validatePasswordOK
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "verify_password",
    type: "password",
    validate: _validate.validatePasswordOK
  }), permissions && !String(permissions).match(/user|pwchange/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "reset_token",
    defaultValue: sessionStorage.getItem('reset_token')
  }), permissions && String(permissions).match(/user|mfarequired/) && /*#__PURE__*/_react.default.createElement(CreateMFAButton, null)), permissions && String(permissions).match(/user/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "API keys",
    toolbar: null
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "apikey",
    target: "uid",
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "prefix"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "expires"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "status"
  }))), /*#__PURE__*/_react.default.createElement(CreateAPIkeyButton, {
    uid: uid
  }))));
};

exports.accountSecurity = accountSecurity;

const accountShow = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Show, _extends({}, props, {
  title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  label: "Person",
  source: "uid",
  reference: "person"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name",
  label: "Username"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
  source: "last_login",
  showTime: true
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanField, {
  source: "totp",
  label: "MFA"
}))); // TODO the grants tab doesn't work yet


exports.accountShow = accountShow;

const accountEdit = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
  title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
  label: "account"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  source: "name",
  label: "Username",
  validate: _validate.validateUsername
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  source: "uid",
  reference: "person",
  label: "Personal details and contact info"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
  source: "password_must_change"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
  source: "totp",
  label: "MFA"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
  source: "status",
  choices: [{
    id: 'active',
    name: 'active'
  }, {
    id: 'disabled',
    name: 'disabled'
  }]
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
  label: "Grants"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
  reference: "grant",
  target: "account_id",
  addLabel: false
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
  rowClick: editGrant
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "value"
}))))));

exports.accountEdit = accountEdit;

const accountList = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.List, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
  rowClick: "show"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  source: "uid",
  label: "User",
  reference: "person"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
  source: "last_login",
  showTime: true
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanField, {
  source: "totp",
  label: "MFA"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "status"
})));

exports.accountList = accountList;

const editGrant = id => {
  var url = new URL(window.location.href);
  return "/grant/".concat(id, "?account_id=").concat(url.hash.split('/')[2]);
};

const MenuUpdateTitle = ({
  record
}) => {
  return /*#__PURE__*/_react.default.createElement("span", null, "Password Update - ", record.username);
};

class RegisterForm extends _react.default.Component {
  constructor(props, context) {
    super(props, context);
    this.state = {
      forgot: props.forgot
    };
  }

  render() {
    return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanInput, {
      source: "forgot_password",
      onChange: e => this.setState(prevState => ({
        forgot: !prevState.forgot
      })),
      defaultValue: this.state.forgot
    }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
      source: "identity",
      label: "Email Address",
      fullWidth: true,
      validate: _validate.validateEmail
    }), /*#__PURE__*/_react.default.createElement("br", null), this.state.forgot || /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
      source: "name",
      label: "Your Full Name",
      fullWidth: true,
      validate: _validate.validateName
    }), /*#__PURE__*/_react.default.createElement("br", null), this.state.forgot || /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
      source: "username",
      label: "Unique Username",
      fullWidth: true,
      validate: _validate.validateUsername
    }));
  }

}

const RegisterToolbar = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Toolbar, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SaveButton, {
  label: "submit",
  submitOnEnter: true
})); // TODO this function (almost verbatim from the CreateEdit reference)
//   throws warning about forwardRef:
// Failed prop type: Invalid prop `component` supplied to
// `ForwardRef(ButtonBase)`. Expected an element type that can hold a ref.


const CreateAPIkeyButton = ({
  uid
}) => /*#__PURE__*/_react.default.createElement(_Button.default, {
  component: _reactAdmin.Link,
  variant: "contained",
  to: {
    pathname: '/apikey/create',
    state: {
      record: {
        uid: uid
      }
    }
  }
}, "Add");

const CreateMFAButton = () => /*#__PURE__*/_react.default.createElement(_Button.default, {
  component: _reactAdmin.Link,
  variant: "contained",
  to: {
    pathname: '/mfa'
  }
}, "MFA");

var _default = accountCreate;
exports.default = _default;