"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.listShow = exports.ListShowTabs = exports.listList = exports.listEdit = exports.listCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _raInputRichText = _interopRequireDefault(require("ra-input-rich-text"));

var _reactMoment = _interopRequireDefault(require("react-moment"));

var _reactRouterDom = require("react-router-dom");

var _queryString = require("query-string");

var _constants = require("../lib/constants");

var _raCustom = require("../lib/ra-custom");

var _validate = require("../lib/validate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const listCreate = props => {
  const {
    uid: uid_string
  } = (0, _queryString.parse)(props.location.state);
  const uid = uid_string || '';
  const redirect = uid ? "/person/".concat(uid, "/show/lists") : 'show';
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, {
    redirect: redirect
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name",
    label: "List",
    validate: _validate.validateNameShort
  }), /*#__PURE__*/_react.default.createElement(_raInputRichText.default, {
    source: "description",
    toolbar: _constants.toolbarOpts
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "privacy",
    choices: _constants.privacyChoices,
    defaultValue: "invitee"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
    source: "category_id",
    reference: "category"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayInput, {
    label: "Members",
    source: "members",
    sort: {
      field: 'name',
      order: 'ASC'
    },
    reference: "person",
    perPage: 40
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteArrayInput, {
    optionText: "name"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "status",
    defaultValue: "active"
  })));
};

exports.listCreate = listCreate;

const listEdit = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
  title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null)
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  source: "name",
  label: "List",
  validate: _validate.validateNameShort
}), /*#__PURE__*/_react.default.createElement(_raInputRichText.default, {
  source: "description",
  label: "Description",
  toolbar: _constants.toolbarOpts
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
  source: "privacy",
  choices: _constants.privacyChoices
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
  source: "category_id",
  reference: "category"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
  optionText: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayInput, {
  label: "Members",
  source: "members",
  sort: {
    field: 'name',
    order: 'ASC'
  },
  reference: "person",
  optionText: "name",
  perPage: 40
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteArrayInput, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  disabled: true,
  source: "status"
})));

exports.listEdit = listEdit;

const listList = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.List, _extends({}, props, {
  exporter: false,
  filters: /*#__PURE__*/_react.default.createElement(ListFilter, null),
  bulkActionButtons: false,
  sort: {
    field: 'name',
    order: 'ASC'
  }
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
  rowClick: "show"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "privacy"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "owner",
  sortable: false
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "category",
  sortable: false
})));

exports.listList = listList;

const ListShowTabs = ({
  record,
  ...props
}) => /*#__PURE__*/_react.default.createElement(_reactAdmin.Show, _extends({}, props, {
  title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null),
  actions: /*#__PURE__*/_react.default.createElement(_raCustom.TopbarNoActions, null)
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedShowLayout, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
  label: "discussion"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
  reference: "message",
  target: "list_id",
  addLabel: false,
  fullWidth: true,
  perPage: 20,
  sort: {
    field: 'created',
    order: 'DESC'
  }
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
  rowClick: "show",
  expand: /*#__PURE__*/_react.default.createElement(MessageDisplay, null)
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  source: "sender_id",
  reference: "person",
  sortBy: "created",
  link: "show"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "subject"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.FunctionField, {
  source: "created",
  render: record => /*#__PURE__*/_react.default.createElement(_reactMoment.default, {
    fromNow: true
  }, record.created)
}), "}")), record.rbac && record.rbac.includes('i') && /*#__PURE__*/_react.default.createElement(CreateMessageButton, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
  label: "members"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name",
  label: "List"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.RichTextField, {
  source: "description"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "privacy"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "category"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceArrayField, {
  source: "members",
  reference: "person",
  perPage: 40
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.SingleFieldList, {
  linkType: "show"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "name",
  label: "Members"
}))), /*#__PURE__*/_react.default.createElement(_reactAdmin.EditButton, null))));

exports.ListShowTabs = ListShowTabs;

const listShow = props => {
  return /*#__PURE__*/_react.default.createElement(_reactAdmin.ShowController, props, controllerProps => /*#__PURE__*/_react.default.createElement(_reactAdmin.ShowView, _extends({
    actions: null,
    title: " "
  }, props, controllerProps), /*#__PURE__*/_react.default.createElement(ListShowTabs, props)));
};

exports.listShow = listShow;

const CreateMessageButton = ({
  record
}) => {
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: {
      pathname: '/message/create',
      state: {
        record: {
          list_id: record.id
        }
      }
    }
  }, "Post");
};

const MessageDisplay = ({
  id,
  record,
  resource
}) => /*#__PURE__*/_react.default.createElement("div", {
  dangerouslySetInnerHTML: {
    __html: record.content
  }
});

const ListFilter = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Filter, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
  source: "category_id",
  reference: "category"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.SelectInput, {
  optionText: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.SearchInput, {
  source: "name"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
  source: "privacy",
  choices: _constants.privacyChoices
}));

var _default = listCreate;
exports.default = _default;