"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.messageShow = exports.messageList = exports.messageEdit = exports.messageCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _raInputRichText = _interopRequireDefault(require("ra-input-rich-text"));

var _moment = _interopRequireDefault(require("moment"));

var _constants = require("../lib/constants");

var _raCustom = require("../lib/ra-custom");

var _validate = require("../lib/validate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function redirect(props) {
  const {
    list_id
  } = typeof props.location.state !== 'undefined' && props.location.state.record; // console.log('redirect list_id=' + list_id);

  return list_id ? "/list/".concat(list_id, "/show") : 'show';
}

const messageCreate = ({
  permissions,
  ...props
}) =>
/*#__PURE__*/
// TODO figure out how to create / display album
_react.default.createElement(_reactAdmin.Create, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, {
  redirect: redirect(props)
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
  label: "Message"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  source: "subject",
  validate: _validate.validateRequired128String
}), /*#__PURE__*/_react.default.createElement(_raInputRichText.default, {
  source: "content",
  toolbar: _constants.toolbarOpts,
  validate: _validate.validateRequired4096String
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  disabled: true,
  source: "privacy",
  defaultValue: "invitee"
}))));

exports.messageCreate = messageCreate;

const messageEdit = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, {
  redirect: redirect(props)
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
  label: "Message"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  source: "subject",
  validate: _validate.validateRequired128String
}), /*#__PURE__*/_react.default.createElement(_raInputRichText.default, {
  source: "content",
  toolbar: _constants.toolbarOpts,
  validate: _validate.validateRequired4096String
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.RadioButtonGroupInput, {
  source: "privacy",
  choices: _constants.privacyChoices
}))));

exports.messageEdit = messageEdit;

const messageList = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.List, _extends({}, props, {
  exporter: false
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
  rowClick: "show",
  expand: /*#__PURE__*/_react.default.createElement(MessageView, null)
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  label: "Sender",
  source: "sender_id",
  reference: "person"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "subject"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
  source: "created",
  label: "Date",
  showTime: true
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "privacy"
})));

exports.messageList = messageList;

const messageShow = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Show, _extends({}, props, {
  title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null),
  actions: /*#__PURE__*/_react.default.createElement(_raCustom.TopbarActions, null)
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleShowLayout, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  label: "Sender",
  source: "sender_id",
  reference: "person"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.FunctionField, {
  label: "Header",
  render: record => "".concat(record.subject, " - ").concat((0, _moment.default)(record.created).fromNow())
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.RichTextField, {
  source: "content"
})));

exports.messageShow = messageShow;

const MessageView = ({
  id,
  record,
  resource
}) => /*#__PURE__*/_react.default.createElement("div", {
  dangerouslySetInnerHTML: {
    __html: record.content
  }
}); // const CreateAlbumButton = ({ ...props }) => {
//     const uid = sessionStorage.getItem('uid')
//     const album = (Math.random() + 1).toString(36).substring(2, 10)
//     return <Button component={Link} variant='contained'
//         to={{
//             pathname: '/album/create',
//             state: { record: { uid: uid, name: `msg-${album}` } },
//         }}>
//         Add
//     </Button>
// }


var _default = messageCreate;
exports.default = _default;