"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.personShow = exports.personList = exports.personEdit = exports.personCreate = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactAdmin = require("react-admin");

var _reactRouterDom = require("react-router-dom");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _raCustom = require("../lib/ra-custom");

var _registry = _interopRequireDefault(require("../lib/registry"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const personCreate = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Create, _extends({}, props, {
  title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null),
  redirect: "show"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.SimpleForm, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  source: "name"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  source: "identity",
  label: "Identity (email)"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceInput, {
  source: "location_id",
  reference: "location"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
  optionText: "name"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  disabled: true,
  source: "status",
  defaultValue: "active"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
  disabled: true,
  source: "privacy",
  defaultValue: "public"
})));

exports.personCreate = personCreate;

const personEdit = ({
  permissions,
  data,
  ...props
}) => {
  var uid = sessionStorage.getItem('uid');
  return /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Edit, _extends({}, props, {
    title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null),
    actions: /*#__PURE__*/_react.default.createElement(_raCustom.TopbarNoActions, null)
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedForm, {
    toolbar: /*#__PURE__*/_react.default.createElement(_raCustom.BottombarSaveOnly, null)
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "identity"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    source: "name"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextInput, {
    disabled: true,
    source: "identity",
    label: "Identity (email)"
  }), permissions && String(permissions).match(/^admin/) && /*#__PURE__*/_react.default.createElement(_reactAdmin.AutocompleteInput, {
    source: "status",
    choices: [{
      id: 'active',
      name: 'active'
    }, {
      id: 'disabled',
      name: 'disabled'
    }]
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "contact info"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "contact",
    target: "uid",
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "label"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "type"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "info"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "privacy"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.BooleanField, {
    source: "muted"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "status"
  }), (permissions && String(permissions).match(/^admin/) || uid === props.id) && /*#__PURE__*/_react.default.createElement(_reactAdmin.EditButton, null), ";")), (permissions && String(permissions).match(/^admin/) || uid === props.id) && /*#__PURE__*/_react.default.createElement(CreateContactButton, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "profile"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "profile",
    target: "uid",
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "edit"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "item"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "value"
  }), (permissions && String(permissions).match(/^admin/) || uid === props.id) && /*#__PURE__*/_react.default.createElement(_reactAdmin.EditButton, null), ";")), (permissions && String(permissions).match(/^admin/) || uid === props.id) && /*#__PURE__*/_react.default.createElement(CreateProfileButton, null)), (0, _registry.default)('picture') && /*#__PURE__*/_react.default.createElement(_reactAdmin.FormTab, {
    label: "Pictures"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
    reference: "album",
    target: "uid",
    filter: {
      list_id: null
    },
    addLabel: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
    rowClick: "show"
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
    source: "name",
    label: "Album"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
    label: "Cover",
    source: "cover_id",
    reference: "picture",
    link: false
  }, /*#__PURE__*/_react.default.createElement(_reactAdmin.ImageField, {
    source: "thumbnail50x50"
  })), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
    source: "privacy"
  }), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
    source: "created"
  }))), /*#__PURE__*/_react.default.createElement(CreateAlbumButton, null)))));
};

exports.personEdit = personEdit;

const personList = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.List, _extends({}, props, {
  pagination: /*#__PURE__*/_react.default.createElement(_raCustom.ListPagination, null),
  exporter: false,
  filters: /*#__PURE__*/_react.default.createElement(ListFilter, null),
  bulkActionButtons: false,
  sort: {
    field: 'name',
    order: 'ASC'
  }
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
  rowClick: "show"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
})));

exports.personList = personList;

const personShow = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Show, _extends({}, props, {
  title: /*#__PURE__*/_react.default.createElement(_raCustom.MenuTitle, null),
  actions: /*#__PURE__*/_react.default.createElement(_raCustom.TopbarActions, null)
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TabbedShowLayout, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
  label: "identity"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  source: "location_id",
  reference: "location",
  link: "show",
  allowEmpty: true
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.FunctionField, {
  render: record => "".concat(record.address, ", ").concat(record.city)
}))), /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
  label: "contact info"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
  reference: "contact",
  target: "uid"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "label"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "type"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "info"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "privacy"
}))), /*#__PURE__*/_react.default.createElement(CreateContactButton, null)), /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
  label: "profile"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
  reference: "profile",
  target: "uid",
  addLabel: false
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.ChipField, {
  source: "item"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "value"
})))), (0, _registry.default)('picture') && /*#__PURE__*/_react.default.createElement(_reactAdmin.Tab, {
  label: "Pictures"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceManyField, {
  reference: "album",
  target: "uid",
  filter: {
    list_id: null
  },
  addLabel: false
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.Datagrid, {
  rowClick: "show"
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.TextField, {
  source: "name",
  label: "Album"
}), /*#__PURE__*/_react.default.createElement(_reactAdmin.ReferenceField, {
  label: "Cover",
  source: "cover_id",
  reference: "picture",
  link: false
}, /*#__PURE__*/_react.default.createElement(_reactAdmin.ImageField, {
  source: "thumbnail50x50"
})), /*#__PURE__*/_react.default.createElement(_reactAdmin.DateField, {
  source: "created"
}))))));

exports.personShow = personShow;

const CreateContactButton = ({
  record,
  permissions
}) => {
  var uid = sessionStorage.getItem('uid');

  if (permissions && String(permissions).match(/^admin/) || record && uid === record.id || record && record.referrer_id === uid) {
    return /*#__PURE__*/_react.default.createElement(_Button.default, {
      component: _reactRouterDom.Link,
      variant: "contained",
      to: {
        pathname: '/contact/create',
        state: {
          record: {
            uid: record.id
          }
        }
      }
    }, "Add");
  } else {
    return /*#__PURE__*/_react.default.createElement("span", null);
  }
};

const CreateProfileButton = ({
  record,
  permissions
}) => {
  var uid = sessionStorage.getItem('uid');

  if (permissions && String(permissions).match(/^admin/) || record && uid === record.id || record && record.referrer_id === uid) {
    return /*#__PURE__*/_react.default.createElement(_Button.default, {
      component: _reactRouterDom.Link,
      variant: "contained",
      to: {
        pathname: '/profile/create',
        state: {
          record: {
            uid: record.id
          }
        }
      }
    }, "Add");
  } else {
    return /*#__PURE__*/_react.default.createElement("span", null);
  }
};

const CreateAlbumButton = ({
  record
}) => {
  return /*#__PURE__*/_react.default.createElement(_Button.default, {
    component: _reactRouterDom.Link,
    variant: "contained",
    to: {
      pathname: '/album/create',
      state: {
        record: {
          uid: record.id
        }
      }
    }
  }, "Add");
};

const ListFilter = props => /*#__PURE__*/_react.default.createElement(_reactAdmin.Filter, props, /*#__PURE__*/_react.default.createElement(_reactAdmin.SearchInput, {
  source: "name"
}));

var _default = personCreate;
exports.default = _default;