"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Card = _interopRequireDefault(require("@material-ui/core/Card"));

var _CardContent = _interopRequireDefault(require("@material-ui/core/CardContent"));

var _reactAdmin = require("react-admin");

var _constants = require("../lib/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// created 26-apr-2019 by rich braun <docker@instantlinux.net>
class VersionInfo extends _react.default.Component {
  constructor(props) {
    super(props);
    this.state = {
      data: null
    };
  }

  componentDidMount() {
    fetch(_constants.apiUrl + '/health').then(response => response.json()).then(data => this.setState({
      version: data.version,
      build_date: data.notes[0]
    }));
  }

  render() {
    const {
      version,
      releaseId,
      build_date
    } = this.state;
    return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("i", null, "Version: ", version, "-", releaseId && releaseId.substring(0, 7), " \u2022 Built: ", build_date && build_date.split("date:")[1]));
  }

}

const aboutPage = () => /*#__PURE__*/_react.default.createElement(_Card.default, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Title, {
  title: "About apicrud UI Example"
}), /*#__PURE__*/_react.default.createElement(_CardContent.default, null, "This framework was created to make it far easier to get started on full-stack development of REST-based services ranging from a simple CLI wrapper for queries of local APIs to full web-scale consumer-facing applications.", /*#__PURE__*/_react.default.createElement("p", null), "The essential components of a modern full-stack application include a back-end API server, a front-end UI server, a database, a memory-cache and a background worker for performing actions such as emailing, photo uploading or report generation.", /*#__PURE__*/_react.default.createElement("p", null), "The rise of Docker and Kubernetes starting around 2017 made it possible to set up these production-grade services directly on the laptop of any developer. Only recently have the tools been easier to configure and set up. This framework provides working example code you can use to get started creating your own secure, web-scale services.", /*#__PURE__*/_react.default.createElement("p", null), "Implementation/design includes these technologies: ", /*#__PURE__*/_react.default.createElement("a", {
  href: "http://www.celeryproject.org/"
}, "celery"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://aws.amazon.com/cloudfront/"
}, "CloudFront and S3"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://www.docker.com/"
}, "docker"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "http://flask.pocoo.org/"
}, "flask"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://kubernetes.io/"
}, "kubernetes"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://developer.mapquest.com/documentation/open/geocoding-api/"
}, "MapQuest geocoding"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://www.mapbox.com/"
}, "mapbox"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://mariadb.org/"
}, "MariaDB"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://oauth.net/2/"
}, "OAuth 2.0"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "](https://pyauth.github.io/pyotp/"
}, "PyOTP"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://docs.python.org/3/"
}, "python 3"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://www.rabbitmq.com/"
}, "RabbitMQ"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://reactjs.org"
}, "react.js"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://marmelab.com/react-admin"
}, "react-admin"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://www.sqlalchemy.org/"
}, "sqlalchemy"), ", ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://uwsgi-docs.readthedocs.io/en/latest/"
}, "uWSGI"), ".", /*#__PURE__*/_react.default.createElement("p", null), "Software copyright \xA9 2021 by Richard Braun \u2022 ", /*#__PURE__*/_react.default.createElement("a", {
  href: "https://www.apache.org/licenses/LICENSE-2.0"
}, "Apache 2.0"), " license ", /*#__PURE__*/_react.default.createElement("p", null), /*#__PURE__*/_react.default.createElement(VersionInfo, null)));

var _default = aboutPage;
exports.default = _default;