"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.cnfrm = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Card = _interopRequireDefault(require("@material-ui/core/Card"));

var _CardContent = _interopRequireDefault(require("@material-ui/core/CardContent"));

var _reactAdmin = require("react-admin");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// created 20-may-2019 by rich braun <docker@instantlinux.net>
const apiUrl = process.env.REACT_APP_API_URL;

const cnfrm = () => {
  return /*#__PURE__*/_react.default.createElement(_Card.default, null, /*#__PURE__*/_react.default.createElement(_CardContent.default, null, /*#__PURE__*/_react.default.createElement(_reactAdmin.Title, {
    title: "Confirming contact"
  }), /*#__PURE__*/_react.default.createElement("p", null), /*#__PURE__*/_react.default.createElement(ActionButtons, null), /*#__PURE__*/_react.default.createElement("p", null)));
};

exports.cnfrm = cnfrm;

class ActionButtons extends _react.default.Component {
  constructor(props) {
    super(props);
    this.state = {
      uid: null,
      error: false
    };
  }

  componentDidMount() {
    const query = window.location.hash.split('?')[1];
    let params = new URLSearchParams(query);
    const token = params.get('token');
    const request = new Request(apiUrl + '/contact/confirm/' + token, {
      method: 'POST'
    });
    fetch(request).then(response => {
      if (response.status !== 200) {
        sessionStorage.removeItem('token');
        sessionStorage.removeItem('auth');
        this.setState({
          error: true
        });
      }

      return response.json();
    }).then(json => {
      sessionStorage.setItem('token', json.jti);
      sessionStorage.setItem('reset_token', token);
      sessionStorage.setItem('uid', json.sub);
      sessionStorage.setItem('auth', json.auth);
      this.setState({
        uid: json.sub,
        auth: json.auth
      });
    });
  }

  render() {
    const {
      uid,
      auth,
      error
    } = this.state;

    if (error) {
      sessionStorage.removeItem('uid');
      return /*#__PURE__*/_react.default.createElement("div", {
        style: {
          textAlign: 'center'
        }
      }, "An expired or invalid token was submitted", /*#__PURE__*/_react.default.createElement("p", null), /*#__PURE__*/_react.default.createElement(_Button.default, {
        component: _reactRouterDom.Link,
        variant: "contained",
        to: "/welcome"
      }, "Home"));
    }

    return /*#__PURE__*/_react.default.createElement("div", null, uid !== undefined && /*#__PURE__*/_react.default.createElement("div", null, "Thank you for confirming your contact information. ", /*#__PURE__*/_react.default.createElement("br", null), auth && !auth.match('pending') && /*#__PURE__*/_react.default.createElement("div", null, "Manage your contact preferences:", /*#__PURE__*/_react.default.createElement("p", null), /*#__PURE__*/_react.default.createElement("div", {
      style: {
        textAlign: 'center'
      }
    }, /*#__PURE__*/_react.default.createElement(_Button.default, {
      component: _reactRouterDom.Link,
      variant: "contained",
      to: {
        pathname: '/person/' + uid
      }
    }, "Manage Identity"))), /*#__PURE__*/_react.default.createElement("p", null)), auth && auth.match('pending') && /*#__PURE__*/_react.default.createElement("div", null, "Set password now, then login to create or update events:"), /*#__PURE__*/_react.default.createElement("p", null), /*#__PURE__*/_react.default.createElement("div", {
      style: {
        textAlign: 'center'
      }
    }, uid !== undefined && /*#__PURE__*/_react.default.createElement(_Button.default, {
      component: _reactRouterDom.Link,
      variant: "contained",
      to: {
        pathname: '/account_password/' + this.state.uid
      }
    }, "Set Password"), /*#__PURE__*/_react.default.createElement(_Button.default, {
      component: _reactRouterDom.Link,
      variant: "contained",
      to: "/event"
    }, "Login")));
  }

}

var _default = cnfrm;
exports.default = _default;